package weaver.interfaces.zkdpoc.crob;

import cn.hutool.core.collection.CollectionUtil;
import org.apache.commons.collections.CollectionUtils;
import weaver.conn.RecordSet;
import weaver.general.TimeUtil;
import weaver.general.Util;
import weaver.interfaces.schedule.BaseCronJob;
import weaver.interfaces.zkdpoc.po.PersonInfoCutPo;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.List;


/**
 * @Author liang.cheng
 * @Date 2024/10/15 9:34 AM
 * @Description: 建模表人员信息切片 poc
 * @Version 1.0
 */
public class PersonInfoCutCrob extends BaseCronJob {


    @Override
    public void execute() {



        RecordSet rs = new RecordSet();

        LocalDate currentDate = LocalDate.now();

        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");

        String formattedDate = currentDate.format(formatter);

        String formattedTime = TimeUtil.getOnlyCurrentTimeString();

        //模块ID
        Integer modeId = 335;

        List<Integer> ids = new ArrayList<>();
        //1.主表数据复制切片
        rs.executeQuery("select id from formtable_main_492 where qprq = ?",formattedDate);

        while (rs.next()) {
            ids.add(Util.getIntValue(rs.getString("id")));
        }

        if (CollectionUtils.isNotEmpty(ids)) {
            String join = CollectionUtil.join(ids, ",");
            rs.execute("delete from formtable_main_492 where  id in ("+join+")");
            rs.execute("delete from formtable_main_492_dt1 where mainid in ("+join+")");
        }


        rs.execute("insert into formtable_main_492(sjyid,zt,field001,field002,field003,field004,field005,field006,field007,zp,fb,gw,htbh,htpq,\n" +
                "htksrq,htjsrq,remark,qx,gwlb,zyjszw,bzlb,sfgjbsh,gjbshjzrq,gjbshczrq,qprq) select id,zt,field001,field002,field003,field004,field005,field006,field007,zp,fb,gw,htbh,htpq,\n" +
                "htksrq,htjsrq,remark,qx,gwlb,zyjszw,bzlb,sfgjbsh,gjbshjzrq,gjbshczrq,DATE_FORMAT(CURDATE(), '%Y-%m-%d') from uf_ryxx");

        //2.更新查询列表所需字段
        rs.executeUpdate("update formtable_main_492 set formmodeid = ?,modedatacreater = ?,modedatacreatedate = ?,modedatacreatetime = ? where" +
                        " qprq = ?", modeId,1,formattedDate,formattedTime,formattedDate);

        //3.更新明细表

        List<PersonInfoCutPo> personInfoCutPos = new ArrayList<>();

        rs.executeQuery("select a.id,a.sjyid,b.field001,b.field002,b.field003,b.field004,b.lcmxid from formtable_main_492 a \n" +
                "INNER JOIN  uf_ryxx_dt1 b on  a.sjyid = b.mainid where a.qprq = ?",formattedDate);

        while (rs.next()) {
            personInfoCutPos.add(PersonInfoCutPo.builder()
                    .id(Util.getIntValue(rs.getString("id")))
                    .oldId(Util.getIntValue(rs.getString("sjyid")))
                    .memberName(Util.null2String(rs.getString("field001")))
                    .namely(Util.null2String(rs.getString("field002")))
                    .workName(Util.null2String(rs.getString("field003")))
                    .jobType(Util.null2String(rs.getString("field004")))
                    .requestId(Util.null2String(rs.getString("lcmxid")))
                    .build());
        }

        personInfoCutPos.forEach(item -> rs.executeUpdate("insert into formtable_main_492_dt1(mainid,field001,field002,field003,field004,lcmxid) values(?,?,?,?,?,?)",
                item.getId(),item.getMemberName(),item.getNamely(),item.getWorkName(),item.getJobType(),item.getRequestId()));
    }
}
